unit MainWindow;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, StdCtrls, ActnList, filectrl, strutils, shellapi,
  zipmodifier, taskdialog0, CheckLst;

type
  TMainWindowFM = class(TForm)
    SrcTypePS: TPageControl;
    StartBT: TButton;
    OpenDialog1: TOpenDialog;
    Label2: TLabel;
    DestEB: TEdit;
    MethodCLB: TCheckListBox;
    Label3: TLabel;
    MultiSrcsTS: TTabSheet;
    SrcsLB: TListBox;
    SrcAddBT: TButton;
    SrcDelBT: TButton;
    OpenDialog2: TOpenDialog;
    Button1: TButton;
    SaveDialog1: TSaveDialog;
    SrcsLBCleanBT: TButton;
    autonamingcb: TCheckBox;
    repeatcb: TCheckBox;
    procedure StartBTClick(Sender: TObject);
    procedure StartBTEnabler(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure SrcAddBTClick(Sender: TObject);
    procedure SrcDelBTClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure SrcsLBCleanBTClick(Sender: TObject);
    procedure autonamingcbClick(Sender: TObject);
    procedure repeatcbClick(Sender: TObject);
  private
    { Private 錾 }
    function methodselected : TZMMethod;
    procedure AnySrcsLBDragDrop(var Msg:TWMDROPFILES); message WM_DROPFILES;
    procedure autodestfilenaming;
  protected
  public
    procedure addsourcefilename( filename : string );
    { Public 錾 }
  end;

var
  MainWindowFM: TMainWindowFM;

implementation

uses version;

{$R *.dfm}

procedure tmainwindowfm.addsourcefilename( filename : string );
begin
  if not fileexists( filename ) then exit;
  SrcsLB.AddItem( filename, nil );

  if  autonamingcb.Checked then autodestfilenaming;

end;

procedure tmainwindowfm.autodestfilenaming;
var ii: integer;
  maybeoutname : string;
  herechar : char;
  len : integer;
  matched : boolean;
  allow: boolean;
begin
  len := 1;
  maybeoutname := '';
  matched := true;
  while matched do
  begin
    if length( srcslb.Items[0]) < len then break;
    herechar := (srcslb.Items[0])[len];
    for ii := 1 to srcslb.Count-1 do
    begin
      if length( srcslb.items[ii] ) <= len then matched := false;
      if srcslb.Items[ii][len] <> herechar then matched := false;
    end;
    if matched then maybeoutname := maybeoutname + herechar;
    inc(len);
  end;
  maybeoutname := changefileext( maybeoutname, '' );

  allow := false;
  if( FileExists( maybeoutname + '.zip' ) ) then
  begin

      for ii := 0 to SrcsLB.Count-1 do
      begin
        if SrcsLB.Items.Strings[ii] = maybeoutname + '.zip' then
        begin
           allow := true;
        end;
      end;

      if not allow and
      ( application.MessageBox( '̓t@Cɒǉ܂H',
                'o̓t@CƓÕt@C܂', MB_YESNO ) = IDYES ) then
      begin
        SrcsLB.Items.Add( maybeoutname + '.zip' );
        allow := true;
      end;
  end;

  if allow then self.DestEB.Text := maybeoutname;

end;

procedure TMainWindowFM.StartBTEnabler(Sender: TObject);
  var multisrc : boolean;
begin
    multisrc := SrcsLB.Count > 2;
    StartBT.Enabled :=
        ( DestEB.Text <> '' )
        and ( multisrc
        or ( ( methodselected <> [] ) or multisrc ) )
        or ( repeatcb.Checked and multisrc )
        ;
end;

type
  TSetWrapper = class
    sets : TZMMethod;
    constructor Create( inset : TZMMethod );
  end;

constructor TSetWrapper.Create( inset : TZMMethod );
begin
  inherited Create;

  sets := inset;
end;

procedure TMainWindowFM.FormCreate(Sender: TObject);

    procedure addmenu( text : string ; isheader,isenable : boolean ; flag : TZMMethod );
        var ii : integer;
    begin
        MethodCLB.additem( text, TSetWrapper.Create( flag ) );
        ii := MethodCLB.Items.Count-1;
        MethodCLB.ItemEnabled[ii] := isenable or isheader;
        MethodCLB.Header[ii] := isheader;
    end;

begin
    Caption := Caption + ' ' + softwareversion;

    addmenu( 't@C̈', true, false, [] );
    addmenu( ' .OLDt', false, true, [ zmmrenameoldzipold ] );

    addmenu( 'dk̓WJ <ŗD>', true, false , [] );
    addmenu( ' i[t@CZIPWJ', false, true , [ zmmextractnestzip ] );

    addmenu( 'i[t@C̃tH_ <2>', true, false , [] );
    addmenu( ' 1iڂ̃tH_Kw팸', false, true , [ zmmpurge1stfolder ] );
    addmenu( ' ZIPt@CtH_ƂđOu', false, true, [ zmmrenamezipheading ] );
    addmenu( 'i[t@C̃t@C̐K', true, false, [] );
    addmenu( ' Z~RƃR폜', false, true, [ zmmvalidatename ] );

    addmenu( 'i[t@Cɏ]ZIPt@C𕪉 <3>', true, false, [] );
    addmenu( ' 1iڂ̃tH_ɏ]`', false, true, [ zmmsliceby1stfolder ] );
    addmenu( ' 2iڂ̃tH_ɏ]`', false, true, [ zmmsliceby2ndfolder ] );
    addmenu( ' 3iڂ̃tH_ɏ]`', false, true, [ zmmsliceby3rdfolder ] );
    addmenu( ' 4iڂ̃tH_ɏ]`', false, true, [ zmmsliceby4rdfolder ] );
    addmenu( ' 5iڂ̃tH_ɏ]`', false, true, [ zmmsliceby5rdfolder ] );
    addmenu( ' (tH_)g', false, true, [ zmmslicepicknumber ] );
    addmenu( ' gqɏ]`', false, true , [ zmmslicebyext ] );

    addmenu( 't@CdĂꍇ̏ <4>', true, false, [] );
    addmenu( ' CRCrďdt@C', false, true, [ zmmpurgeduplicatebycrc ] );

    DragAcceptFiles( Handle, true );

end;

function TMainWindowFM.methodselected : TZMMethod;
var ii: integer;
    zmopt : TZMMethod;
begin
    zmopt := [];
    for ii := 0 to MethodCLB.Count-1 do
    begin
      if MethodCLB.Checked[ii] then
      begin
        zmopt := zmopt + ( methodCLB.items.objects[ii] as TSetWrapper ).sets;
      end;
    end;
    result := zmopt;
end;

procedure TMainWindowFM.StartBTClick(Sender: TObject);
    var
        task : TZipModifier;
        ii : integer;
    //    zmopt : TZMMethod;
       name :string;
begin
  //  OnceSrcTS.Enabled := false;
    Hide;

    if self.repeatcb.Checked
    then begin
       for ii := 0 to Srcslb.Count-1 do
       begin
          name := srcslb.Items[ii];
          task := TZipModifier.Create(self);
          task.sourcefile := name;
          task.destbasename := changefileext( name, '' );

          task.method := methodselected;
          task.Show;
          task.invoke;
    // task.Release;
       end;
       srcslb.Clear;
    end
    else begin
        task := TZipModifier.Create( self );
          for ii := 0 to SrcsLB.Count-1 do
            task.sourcefile := SrcsLB.Items[ii];
        srcslb.Clear;

        task.destbasename := DestEB.Text;

        task.method := methodselected;
        task.Show;
        task.invoke;
        // task.Release;
    end;

    Show;
end;

procedure TMainWindowFM.SrcAddBTClick(Sender: TObject);
begin
  OpenDialog2.FileName := '';
  if OpenDialog2.Execute then
  begin
    SrcsLB.Items.AddStrings( OpenDialog2.Files );
  end;
end;

procedure TMainWindowFM.SrcDelBTClick(Sender: TObject);
begin
  if SrcsLB.ItemIndex >= 0 then
    SrcsLB.Items.Delete( SrcsLB.ItemIndex );
  StartBTEnabler(Sender);
end;

procedure TMainWindowFM.Button1Click(Sender: TObject);
  var name : string;
begin
  SaveDialog1.FileName := DestEB.Text + '.ZIP';
  if SaveDialog1.Execute then
  begin
    name := SaveDialog1.FileName;
    DestEB.Text := changefileext( name, '' );
  end;
end;

procedure TMainWindowFM.AnySrcsLBDragDrop(var Msg:TWMDROPFILES);
  var
    ii,count : integer;
    filename : array [ 0..255 ] of char;
begin
  count := Dragqueryfile(msg.drop,cardinal(-1), nil, 0);
      for ii := 0 to count-1 do
      begin
        DragQueryFile(Msg.Drop, ii, FileName, SizeOf(FileName)-1);
        addsourcefilename( filename );
      end;
end;

procedure TMainWindowFM.SrcsLBCleanBTClick(Sender: TObject);
begin
  if ( srcslb.Count > 0 ) and
        ( application.MessageBox( '܂H', 'S폜', MB_YESNO ) = IDYES ) then
  begin
    SrcsLB.Clear;
  end;
  StartBT.Enabled := false;
end;

procedure TMainWindowFM.autonamingcbClick(Sender: TObject);
var ro : boolean;
begin
  ro :=  autonamingcb.Checked;
  DestEB.ReadOnly := ro;
  Button1.Enabled := not ro;
end;

procedure TMainWindowFM.repeatcbClick(Sender: TObject);
begin
  self.DestEB.Enabled := self.repeatcb.Checked;
  self.StartBTEnabler(sender);
end;

end.
